<?
 /**
 * Extra Controller for Pressbackup.
 *
 * This Class provide misc function that are called automaticaly at some point
 *
 * Licensed under The GPL v2 License
 * Redistributions of files must retain the above copyright notice.
 *
 * @link				http://pressbackup.com
 * @package		controlers
 * @subpackage	controlers.extra
 * @since			0.5
 * @license			GPL v2 License
 */

class PressbackupExtra {

	/**
	 * Check if the scheluded taks is active and active otherwise
	 * Also check for missing preferences added between versons
	 * Note: this function its called at the init of the plugin
	*/
	public function checks ()
	{
		//tools
		global $pressbackup;
		$settings= get_option('pressbackup_preferences');
		if(!$settings){
			$settings= get_option('pressbackup.preferences');
		}

		//check for new preferences
		$need_update = false;

		if(isset($settings['pressbackup'])){

			$aux = $settings['pressbackup'];

			$aux['Service']['pressbackuppro'] = (isset($aux['pressbackuppro']))?$aux['pressbackuppro']:array('credential' => '');
			unset($aux['pressbackuppro']);

			$aux['Service']['pressexpress'] = (isset($aux['pressexpress']))?$aux['pressexpress']:array('credential' => '');
			unset($aux['pressexpress']);

			$aux['Service']['dropbox'] = (isset($aux['dropbox']))?$aux['dropbox']:array('credential' => '');
			unset($aux['dropbox']);

			$aux['Service']['local'] = (isset($aux['local']))?$aux['local']:array('path' => '');
			unset($aux['local']);

			$aux['Service']['s3'] = (isset($aux['s3']))?$aux['s3']:array('credential' => '', 'bucket_name'=>'', 'region'=>false);
			unset($aux['s3']);

			$settings = $aux;

			$need_update = true;
		}

		if (!isset($settings['compatibility']['background'])){
			$settings['compatibility']['background']=10;
			$need_update = true;
		}

		if (!isset($settings['compatibility']['zip'])){
			$settings['compatibility']['zip'] = 10;
			$need_update = true;
		}

		if (!isset($settings['Service']['s3']['bucket_name'])){
			$settings['Service']['s3']['bucket_name'] = '';
			$need_update = true;
		}

		if (!isset($settings['backup_advanced']['activated'])){
			$settings['backup_advanced']['activated'] = false;
			$settings['backup_advanced']['db']= array('time' => null, 'last_date' => null);
			$settings['backup_advanced']['plugins']= array('time' => null, 'last_date' => null);
			$settings['backup_advanced']['themes']= array('time' => null, 'last_date' => null);
			$settings['backup_advanced']['uploads']= array('time' => null, 'last_date' => null);
			$need_update = true;
		}

		if($need_update) {
			update_option('pressbackup.preferences',$settings);
			delete_option('pressbackup_preferences');
		}

		//remove old schedules
		@wp_clear_scheduled_hook('pressback_backup_start_cronjob');
		@wp_clear_scheduled_hook('pressback_backupnow_save');
		@wp_clear_scheduled_hook('pressback_backupnow_save_ajax');
		@wp_clear_scheduled_hook('pressback_backupnow_download');
		@wp_clear_scheduled_hook('pressback_backupnow_download_ajax');

		//set the type of service use to get/show backups
		$pressbackup->import('Misc.php');
		$misc = new MiscPBLib();
		$service = $misc->currentService();

		//set the type of credential to see what option show in this page
		$credentials = ($service['id'] != 'none' );

		//fix to missing schedule
		if ($credentials && !$ns=wp_next_scheduled('pressbackup.cron.doBackupAndSaveIt')){
			$pressbackup->import('Scheduler.php');
			$sch = new SchedulerPBLib();
			$sch->add();
		}

		return true;
	}

	/**
	 * Restore the permalinks
	 *
	 * called after a restore is done
	 * Note: this function its called at the admin init
	 */
	public function restoreHtaccess ()
	{
		//tools
		global $wp_rewrite;

		$settings= get_option('pressbackup.preferences');

		if(isset($settings['restore'])){
			$wp_rewrite->flush_rules();

			unset($settings['restore']);
			update_option('pressbackup.preferences',$settings);
		}
		return true;
	}

	public function ping ()
	{
		//tools
		global $pressbackup;

		$pressbackup->import('ServicePressbackup.php');
		$srv = new ServicePressbackupPBLib();

		$response = $srv->ping();

		return true;
	}

}
?>
