<?

Class DashHelperPBLib
{

	public $types_names = null;
	public $types_numbers = null;
	public $fp = null;

	public function __construct()
	{ 
		global $pressbackup;

		$this->fp = &$pressbackup;
		$this->types_names = array(__('Database','pressbackup'), ' '.__('Themes','pressbackup'), ' '.__('Plugins','pressbackup'), ' '.__('Uploads','pressbackup'));
		$this->types_numbers = array(7, 5, 3, 1);
	}

	public function currentSettings ()
	{
		//tools
		$settings= get_option('pressbackup.preferences');

		$this->fp->import('Misc.php');
		$misc = new MiscPBLib();

		$this->fp->import('Scheduler.php');
		$sch = new SchedulerPBLib();

		//get the type of credential
		$service = $misc->currentService();
		$advanced_backups = $settings['backup_advanced']['activated'];

		$activated_type = str_replace( $this->types_numbers, $this->types_names, $settings['backup']['type'] );
		$next_type = null;
		$schedule = __('Disabled','pressbackup');
		$storage_service = '--';

		if($service['id'] != 'none' && !$advanced_backups) {
			$schedule = __('Next on','pressbackup').': '.date_i18n('M d, H:i', wp_next_scheduled('pressbackup.cron.doBackupAndSaveIt'));
		}

		if($service['id'] != 'none' && $advanced_backups) {
			$activated_type  = str_replace( $this->types_numbers, $this->types_names, $sch->activatedTasks() );
			$next_type  = str_replace( $this->types_numbers, $this->types_names, $sch->nextScheduledTasks() );
			$schedule = __('Next on','pressbackup').': '.date_i18n('M d, H:i', wp_next_scheduled('pressbackup.cron.doBackupAndSaveIt')).' ( '.__('Will backup','pressbackup').': '.$next_type.' )';
		}

		return
		'
		<div class="left">
			<h3 style="margin-bottom: 0px;">'.__('Backup type', 'pressbackup').'</h3>
			<p style="margin-top: 5px;">'.$activated_type.'</p>
		</div>
		<div class="left" style="margin-left: 100px">
			<h3 style="margin-bottom: 0px;">'.__('Scheduled backups', 'pressbackup').'</h3>
			<p style="margin: 5px 0 5px;">'.$schedule.'</p>
		</div>
		<div class="clear"></div>
		';
	}

	public function paginator ($pagination = array())
	{
		if(!$pagination || $pagination['total'] < 5){
			return '&nbsp;';
		}

		$output = null;

		if (($pagination['page'] < $pagination['pages']) &&($pagination['page']==1))
		{
			$pageNext=$pagination['page'] + 1;
			$next = $pagination['func_path']; $next[] .= $pageNext;
			$last = $pagination['func_path']; $last[] .= $pagination['pages'];

			$output=	"<span class=\"displaying-num\">".sprintf(__('Displaying %1$s - %2$s of %3$s.','pressbackup'), '1', $pagination['pagination'], $pagination['total'])."</span> ".
						$this->Html->link(__('Next','pressbackup'), $next, array('class'=>'button abpdding') )." ".
						$this->Html->link(__('Last','pressbackup'), $last, array('class'=>'button abpdding') );
		}
		elseif (($pagination['page'] < $pagination['pages']) &&($pagination['page'] >1))
		{
			$pageNext=$pagination['page'] + 1;
			$pagePrev=$pagination['page'] - 1;
			$first = $pagination['func_path']; $first[] .= '1';
			$next = $pagination['func_path']; $next[] .= $pageNext;
			$prev = $pagination['func_path']; $prev[] .= $pagePrev;
			$last = $pagination['func_path']; $last[] .= $pagination['pages'];

			$output =	"<span class=\"displaying-num\">".sprintf(__('Displaying %1$s - %2$s of %3$s.','pressbackup'), $pagination['ini'], $pagination['fin'], $pagination['total'])."</span> ".
							$this->Html->link(__('First','pressbackup'), $first, array('class'=>'button abpdding') )." ".
							$this->Html->link(__('Prev','pressbackup'), $prev, array('class'=>'button abpdding') )." ".
							$this->Html->link(__('Next','pressbackup'), $next, array('class'=>'button abpdding') )." ".
							$this->Html->link(__('Last','pressbackup'), $last, array('class'=>'button abpdding') );
		}
		elseif (($pagination['page'] == $pagination['pages']) &&($pagination['pages'] !=1))
		{
			$pagePrev=$pagination['page'] - 1;
			$first = $pagination['func_path']; $first[] .= '1';
			$prev = $pagination['func_path']; $prev[] .= $pagePrev;

			if ($pagination['fin'] > $pagination['total']) {$pagination['fin'] = $pagination['total'];}
			$output =	"<span class=\"displaying-num\">".sprintf(__('Displaying %1$s - %2$s of %3$s.','pressbackup'), $pagination['ini'], $pagination['fin'], $pagination['total'])."</span> ".
							$this->Html->link(__('First','pressbackup'), $first, array('class'=>'button abpdding') )." ".
							$this->Html->link(__('Prev','pressbackup'), $prev, array('class'=>'button abpdding') );
		}
		elseif(($pagination['pages'] == 1)&&($pagination['total']!=0))
		{
			$output = "<span class=\"displaying-num\">".sprintf(__('Displaying %1$s - %2$s of %3$s.','pressbackup'), '1', $pagination['total'], $pagination['total'])."</span>";
		}
		return $output;
	}


	public function __get($name)
	{
		if(isset($this->fp->$name)) {
			return $this->fp->$name;
		}
	}

}

?>
