<?php
/*
Plugin Name: PressBackup
Plugin URI: http://pressbackup.com
Description: Easily backup your WordPress site using our cloud service or DropBox, Amazon S3, or a local folder. Pro Service requires a PressBackup.com  membership to use.
Author: Infinimedia Inc.
Version: 1.6
Author URI: http://infinimedia.com/
*/
	//init framework
	require_once(dirname(__FILE__) . '/' . '.core' . '/' . 'init.php');
	global $FramePress;

	//Create a global instance of framepress, choose a unique name
	global $pressbackup;
	$pressbackup = new $FramePress(__FILE__);

	//Admin pages to add
	$wp_pages = array (
		'menu' => array (
			array (
				'page.title' => 'PressBackup',
				'menu.title' => 'PressBackup',
				'capability' => 'administrator',
				'controller' => 'main',
				'function' => 'index',
				'icon' => 'logo16.png',
			),
		),
		'submenu' => array (
			array (
				'parent' => 'PressBackup',
				'page.title' => 'PressBackup',
				'menu.title' => 'Settings',
				'capability' => 'administrator',
				'controller' => 'settings',
				'function' => 'index',
			),
		),
	);

	$wp_actions = array (

		//save (for scheduled jobs)
		//called on WP doing cron 
		array(
			'tag' => 'pressbackup.cron.doBackupAndSaveIt',
			'controller' => 'main',
			'function' => 'createBackupAndSaveIt',
		),

		//save and download (for backup now && compatibility soft)
		//called on main::backupStart 
		array(
			'tag' => 'pressbackup.main.doBackupAndSaveIt',
			'controller' => 'main',
			'function' => 'createBackupAndSaveIt',
		),
		array(
			'tag' => 'pressbackup.main.doBackupAndDownloadIt',
			'controller' => 'main',
			'function' => 'createBackupAndDownloadIt',
		),

		//save and download ajax (for backup now && compatibility medium)
		//called on main::backupStart 
		array(
			'tag' => 'pressbackup.ajax.doBackupAndSaveIt',
			'controller' => 'main',
			'function' => 'createBackupAndSaveIt',
			'is_ajax' => true
		),
		array(
			'tag' => 'pressbackup.ajax.doBackupAndDownloadIt',
			'controller' => 'main',
			'function' => 'createBackupAndDownloadIt',
			'is_ajax' => true
		),

		// check main|ajax|cron status
		//called via ajax on dash pages 
		array(
			'tag' => 'pressbackup.main.chkCronBackupStatus',
			'controller' => 'main',
			'function' => 'cronBackupStatus',
			'is_ajax' => true,
		),

		// create test cron task (wizard check)
		//called on settigs::configInit and configInit page
		array(
			'tag' => 'pressbackup.wizard.doCronTask',
			'controller' => 'settings',
			'function' => 'wizardStartCronTask'
		),
		array(
			'tag' => 'pressbackup.wizard.chkCronTaskStatus',
			'controller' => 'settings',
			'function' => 'wizardChkCronTaskStatus',
			'is_ajax' => true,
		),

		// Ping
		array(
			'tag' => 'pressbackup.ping',
			'controller' => 'extra',
			'function' => 'ping',
		),

		// check for incompatibilities with previous versions
		array(
			'tag' => 'init',
			'controller' => 'extra',
			'function' => 'checks',
		),

		//function called after a restore
		array(
			'tag' => 'admin_init',
			'controller' => 'extra',
			'function' => 'restoreHtaccess',
		),
	);

	$pressbackup->Page->add($wp_pages);
	$pressbackup->Action->add($wp_actions);

	//@wp_clear_scheduled_hook('pressbackup.ping');
	if (!wp_next_scheduled('pressbackup.ping')){
		//wp_schedule_event(strtotime('now'), 'daily', 'pressbackup.ping');
	}
?>
